#!/usr/local/bin/perl
#
#
# Mu-Cheng Hsieh <mucheng@cc.nthu.edu.tw>
# 2003/10/27
#

use IO::Socket;

my $home_dir = "/usr/local/notify";
my $guard_dir = "/usr/local/netguard";
my $block_queue_dir = "$guard_dir/spool/block";
my $inform_mail = "$home_dir/etc/inform.mail";
my $log = "/usr/local/notify/log/sendmail";

my $my_ip = '';
my $my_data = '';

my $subnet_db = "$home_dir/etc/subnet";
my $addressbook_db = "$home_dir/etc/addressbook";

my %SUBNET_DEPT = ();
open FH, "$subnet_db";
while(<FH>){
  chop;
  next if (/^#/);	# comment
  my ($subnet, $building, $dept) = split /:/;
  $SUBNET_DEPT{$subnet} = $dept;
}
close FH;

my %DEPT_EMAIL = ();
open FH, "$addressbook_db";
while(<FH>){
  chop;
#:mW:¾:q:ǯu:qllHc
  next if (/^#/);	# comment
  my ($dept, $name, $title, $phone, $fax, $email) = split /:/;
  if ( defined $DEPT_EMAIL{$dept} ) {
    $DEPT_EMAIL{$dept} .= ",$email";
  } else {
    $DEPT_EMAIL{$dept} = $email;
  }
}
close FH;

my ($mysec, $target, $type, $mac);

my $i = 0;
open BLOCK, "/bin/ls $block_queue_dir|";
while(<BLOCK>){
  my ($mysec, $target, $type, $mac) = file_filter("$block_queue_dir/$_");

  if ( $target =~ /^(\d+\.\d+\.\d+)\.\d+/ ){
    $subnet = $1;
  } else {
    $subnet = $target;
  }

  $my_ip = $target;
  $my_data = "ɶ: ".scalar localtime($mysec).
               "\nD: [$target]\n: $type";

  if ( $mac ne 'UNKNOWN' ) {
    $my_data .= "\nMAC: $mac\n";
  }

  $i++;
  print "$i $SUBNET_DEPT{$subnet} $DEPT_EMAIL{$SUBNET_DEPT{$subnet}}\n";
  if ( defined $DEPT_EMAIL{$SUBNET_DEPT{$subnet}} ) {
    sendmail($DEPT_EMAIL{$SUBNET_DEPT{$subnet}});
  } else {
    print "Null email\n";
  }
  #last; 
}

close BLOCK;

exit;

sub sendmail_log{
  my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
  $year+=1900;
  $mon++;
  open(LOG, ">> $log");
  printf LOG "%4d/%02d/%02d %02d:%02d:%02d ",$year,$mon,$mday,$hour,$min,$sec;
  print LOG @_, "\n";
  close(LOG);
}

#
sub sendmail{
  my ($recipients) = @_;
  
  open FH, "$inform_mail";
  my @lines = <FH>;
  close FH;

  sendmail_log("[$$] cron-sendmail to $recipients");

  my $socket = IO::Socket::INET->new (PeerAddr => "smtp.school.edu.tw",
                                      PeerPort => 25,
                                      Proto    => "tcp",
                                      Type     => SOCK_STREAM)
     or die "Couldn't connect to smtp server: $@\n";

  my $msg = <$socket>;
  # 220
  if ( $msg !~ /^2/ ) {
    goto QUIT;
  }

  print $socket "HELO smtp.school.edu.tw\n";
  $msg = <$socket>;
  # 250
  if ( $msg !~ /^2/ ) {
    goto QUIT;
  }

  print $socket "MAIL FROM:<antivir\@cc.shool.edu.tw>\n";
  $msg = <$socket>;
  # 250
  if ( $msg !~ /^2/ ) {
    informLog("$msg");
    goto QUIT;
  }

  (@recipient) = split /,/, $recipients;
  foreach (@recipient) {
    print $socket "RCPT TO:<$_>\n";
    $msg = <$socket>;
    # 250
    if ( $msg !~ /^2/ ) {
      goto QUIT;
    }
  }

  print $socket "RCPT TO:<virus\@cc.school.edu.tw>\n";
  $msg = <$socket>;
  # 250
  if ( $msg !~ /^2/ ) {
    goto QUIT;
  }

  print $socket "DATA\n";
  $msg = <$socket>;
  # 354
  if ( $msg !~ /^3/ ) {
    goto QUIT;
  }

  print $socket "To: $recipients\n";

  foreach (@lines) {
    s/#IP#/$my_ip/g;
    s/#DATA#/$my_data/g;
    print $socket $_;
  }

  print $socket "\n.\n";
  $msg = <$socket>;
  # 250
  if ( $msg !~ /^2/ ) {
    goto QUIT;
  }

  sendmail_log("[$$] inform $my_ip success");
QUIT:
  print $socket "QUIT\n";
  $msg = <$socket>;
  close $socket;
}


sub file_filter{
  my ($file) = @_;
  ($my_peeraddr, $my_timestamp, $my_time, $my_ymd, $my_hms) = ();

  $mac = 'UNKNOWN';
  open FH, "$file";
  while(<FH>){
    chop();
    if (/BLOCK_IP_TIMESTAMP:\s+(.*)/) {
      $timestamp = $1;
    } elsif (/^REQUEST_TARGET:\s+(.*)/) {
      $target = $1;
    } elsif (/^REQUEST_REASON:\s+(.*)/) {
      $reason = $1;
    } elsif (/^TARGET_MAC:\s+(.*)/) {
      $mac = $1;
    } 
  }
  close FH;
  return  $timestamp, $target, $reason, $mac; 
}
