#!/usr/local/bin/perl
#
# Mu-Cheng <mucheng@cc.nthu.edu.tw>
# 2003/10/09
#

my $home = "/usr/local/notify";
my $guard = "/usr/local/netguard";
my $subnet_db = "$home/etc/subnet";
my $ban_htm="$home/htdocs/block.htm";
my $ban_head="$home/htdocs/ban-head.htm";
my $ban_tail="$home/htdocs/ban-tail.htm";
my $block_dir= "$guard/spool/block";
my $unblock_dir= "$guard/spool/unblock";
my %UNBLOCK = ();
my $book_queue_dir= "$guard/spool/book";
my %BOOK=();

# get order info
open FH, "/bin/ls $book_queue_dir|";
my @lines = <FH>;
close FH;
foreach (@lines) {
  chop();
  if ( /^(\S+)$/ ) {
    $BOOK{$1} = "FINISH";
    print "BOOK: [$1] -> $BOOK{$1}\n";
  }
}

# get unblock info
open FH, "/bin/ls $unblock_dir|";
@lines = <FH>;
close FH;
foreach (@lines) {
  chop();
  my ($ip, $unblock_time) = split /\,/; 
  if ( defined $UNBLOCK{$ip} ) {
    $UNBLOCK{$ip}++;
  } else {
    $UNBLOCK{$ip} = 1;
  }
  print "UNBLOCK: $ip -> $UNBLOCK{$ip}\n"; 
}

# get subnet
open FH, "$subnet_db";
while(<FH>){
  chop;
  my ($subnet, $building, $dept) = split /:/;
  $SUBNET_DEPT{$subnet} = $dept;
}
close FH;

#
open FH, "$ban_head";
my @head = <FH>;
close FH;

open FH, "$ban_tail";
my @tail = <FH>;
close FH;

#open BAN, "/bin/ls -tr $block_dir|";
open BAN, "/bin/ls $block_dir| /bin/sort -t . -k1,1n -k2,2n -k3,3n -k4,4n|";
@lines = <BAN>;
close BAN;

my $now = scalar localtime();
open TARGET, "> $ban_htm";

print TARGET << "EOF";
@head
<p>
<br>Cɶ: $now</b></font>
<br>
<center>
<table border=1>
<tr bgcolor=lightblue>
<th>Ǹ</th><th>_ɶ</th><th>IP/Network</th><th>޲z</th>
<th></th><th>Ƶ</th>

EOF

my $i=0;
foreach  (@lines){
  chop;
  $i++;
  open FH, "$block_dir/$_";
  $block_ip_time = '';
  $target = '';
  $reason = '';
  $comment = '';
  $mac = '';
  while(<FH>){
    chop();
#BLOCK_IP_TIME: 20031009.16:20:55.41415
    if (/^BLOCK_IP_TIME:\s+(\d{4})(\d{2})(\d{2})\.(\S+)\./) {
      $block_ip_time = "$1/$2/$3 $4";
    } elsif (/^REQUEST_TARGET:\s+(.*)/) {
      $target = $1;
    } elsif (/^REQUEST_REASON:\s+(.*)/) {
      $reason = $1;
    } elsif (/^REQUEST_COMMENT:\s+(.*)/) {
      $comment = $1;
    } elsif (/^TARGET_MAC:\s+(.*)/) {
      $mac = $1;
    }
  }

  close FH;

  print "BAN: [$target] $BOOK{$target}\n";
  ($subnet) = $target =~ /(\d+\.\d+\.\d+)\.\d+/;
  print TARGET "<tr><td>$i</td><td>$block_ip_time</td><td>$target</td><td>$SUBNET_DEPT{$subnet}</td><td><a href=#$reason>$reason</a></td>";
  if ( defined $BOOK{$target} ) {
     if ( $BOOK{$target} eq "FINISH" ) {
       print TARGET "<td><font color=green>Bz</font></td>";
     } elsif ( $BOOK{$target} eq "UNFINISH" ) {
       print TARGET "<td><font color=red>bBz</font></td>";
     } else {
       print TARGET "<td>$BOOK{$target}</td>";
     }
  } else {
     $UNBLOCK{$target} = "@" unless ( defined $UNBLOCK{$target} );
     print TARGET "<td>$UNBLOCK{$target}</td>";
  }
  print TARGET "<input type=hidden value=$mac>\n";
}

print TARGET "<tr bgcolor=lightblue><th colspan=6>`p $i </th>\n";
print TARGET << "EOF";
</table>
@tail
EOF
close TARGET;
